<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources.'lib/validate_function.php';
require_once $base_path_to_learning.'user_management/authenticate.php';
require_once $base_path_to_learning.'functions/common_functions.php';

require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;
//db access function
require_once $base_path_to_learning_resources.'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();

if ( !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or  !isset($postdata['subject_id']) or !checkIfIssetAndNotEmpty($postdata['subject_id']) or   !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or 
!isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or !isset($postdata['jwt_token']) or  !isset($postdata['jwt_token'])) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific, $version, $updated_time, $userid, $postdata['institution_id']);

function getSpecificSubject($conn_rjllearning_specific,$institution_id,$subject_id) {
    // reeturns all data from the specific row of the profile
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM  subject_info where id = ? and institution_id =?");
    $sql->execute(array($subject_id,$institution_id));
    $rows = $sql->fetchAll();

    if (count($rows) == 1) {
         if ($rows[0]['icon'] != null and !is_array($rows[0]['icon'])) {
            $data_attachment = json_decode($rows[0]['icon'], true);
            $filePath = $data_attachment['filepath'];
            $originalName = $data_attachment['original_name'];
            $aws_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
            //$final_array_icon   = array("filepath" => $aws_attachment, "original_name" => $originalName);
        } else {
            $aws_attachment =  null;
        }
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows[0]['class_id']);
   
        return array('subject_id' => $rows[0]['id'],'class_id' => $class_info,'type' => $rows[0]['type'],'subject_name' => $rows[0]['subject_name'], 'icon' => $aws_attachment);
      
    }else{
          errorreturn("Subject not found.");
    }

}

if($postdata['function_type']  == "fetch_specific_subject") {  
    $subject_id = trim($postdata['subject_id']);
    $institution_id = trim($postdata['institution_id']);  
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific,$institution_id);
    if($check_academic_confirmation != true){
         errorreturn("Access denied. Academic session not active.");
    }
    $success['data'] = getSpecificSubject($conn_rjllearning_specific,$institution_id,$subject_id);
    successreturn($success);
      
}

